#!/usr/bin/env python3.4
# -*- coding: utf-8 -*-
#
#  SenseHat-2.py	24 Janvier 2017
#  
#  Copyright 2017  <pi@CDBI-PI3>
#
#BOUTONS PIFACE
#0	Arret
#1	Affiche température + BareGraphe
#2	Affiche Température+Humidité
#3	Affiche Température+Humidité+Pression
#4	Lance l'enregistrement dans un fichier MesuSHxxxx

#On ne peut stopper la matrice pendant un message

import os
from sense_hat import SenseHat
from time import sleep
import pifacedigitalio as pfio
from datetime import datetime
sense = SenseHat()

#===================================================================
def BareG(cpt):
	sense.clear()
	#Affiche la list TabT
	#Recherche du Max et ajustement du Min
	#Dynamique de 8°c  (8 Pixels)
	tmax=0
	for x in range (0,len(tabT)):
		if tmax < int(tabT[x])+2:
			tmax=int(tabT[x])+2
	tmin=tmax-8

	if tmin < 2:
		tmax=tmax+2
		tmin=tmax-8
	sense.show_message(str(tmax),text_colour=[100,0,80])

	for x in range (0,8):
		if x == (cpt+1):
			break
		temp=int(tabT[x])-tmin
		if (temp >= 0) and (temp < 9):
			for y in range (0,temp):
				sense.set_pixel(x,y,100,0,80)
				#for y in range (temp,8):
					#sense.set_pixel(x,y,0,50,0)
		else:
			for y in range (0,8):
				sense.set_pixel(x,y,0,0,0)
	sense.flip_v()
	sleep(2)

#===================================================================
def SW_pressed(event):
	numB=event.pin_num
	sleep(0.3)
	sense.clear()

#===================================================================
def SW_unpressed(event):
	global Mesu
	global Fichier
	global NomFich
	sleep(0.5)
	sense.clear()
	if event.pin_num == 4:
		#Création du fichier
		if Fichier == False:
			NomFich="MesuSH" + datetime.now().strftime('-%H%M%S') + '.txt'
			nF=open(NomFich,"w")
			nF.write("RELEVE CLIMATIQUE-SENSEHAT  CDBI-PI3\n")
			nF.write("====================================\n")
			Fichier=True
	else:
		Mesu=event.pin_num

#===================================================================
def Fermer():
	flagRUN=False
	sense.show_letter("A",text_colour=[200,100,100])
	sleep(2)
	sense.clear()
	listener.deactivate()
	pfio.deinit()
	if Fichier == True:
		nF.close()
	print ("\nARRET")

#==========================MAIN=====================================
pfio.init()
pfd=pfio.PiFaceDigital()
listener=pfio.InputEventListener(chip=pfd)
for i in range(5):
	listener.register(i,pfio.IODIR_ON,SW_pressed)
	listener.register(i,pfio.IODIR_OFF,SW_unpressed)
listener.activate()
sense.clear()

tabT=[]			#Liste des 8 dernières Températures
cpt=0			#Compteur de 0 à 7 pour le BarGraphe
Mesu=-1			#Nombre de Mesures renvoyé par les boutons
Vit=0.1			#Vitesse de défilement de la Matrice
Tlapse1=2		#Temps entre chaque cycle de mesure
Fichier=False	#Enregistrement ou non
flagRUN=False	#Boucle while principale
nF=0

while (Mesu == -1):
	sense.show_message("CDBI ?",scroll_speed=0.2,text_colour=[150,150,0],back_colour=[0,50,0])
	if Mesu == 0:
		Tlapse2=0
		Fermer()
		break
	else:
		flagRUN=True
		Tlapse2=Tlapse1
sense.show_letter(str(Mesu),text_colour=[150,150,0],back_colour=[0,50,0])
sleep(2)

while (flagRUN):
	try:
		t=sense.get_temperature()
		tabT.append (round(t,2))
		h=sense.get_humidity()
		p=sense.get_pressure()
		t='T='+str(round(t,1))
		h='H= '+str(round(h,1))
		p='P= '+str(round(p,1))

		if Fichier == True:
			nF=open(NomFich,"a")
			Timestamp=datetime.now().strftime('%d-%m-%Y_%H:%M:%S  ')
			L=Timestamp + t + '  ' + h + '  ' + p
			print (L)
			nF.write(L + "\n")

		if Mesu == 0:
			Fermer()
			break
		elif Mesu == 1:
			sense.show_message(t,scroll_speed=Vit,text_colour=[150,150,0],back_colour=[50,0,0])
		elif Mesu == 2:
			sense.show_message(t,scroll_speed=Vit,text_colour=[150,150,0],back_colour=[50,0,0])
			if Mesu == 0:
				Fermer()
				break
			sense.show_message(h,scroll_speed=Vit,text_colour=[150,150,0],back_colour=[0,0,50])
		elif Mesu == 3:
			sense.show_message(t,scroll_speed=Vit,text_colour=[150,150,0],back_colour=[50,0,0])
			if Mesu == 0:
				Fermer()
				break
			sense.show_message(h,scroll_speed=Vit,text_colour=[150,150,0],back_colour=[0,0,50])
			if Mesu == 0:
				Fermer()
				break
			sense.show_message(p,scroll_speed=Vit,text_colour=[200,150,0],back_colour=[0,50,0])

		if Mesu == 0:
			Fermer()
			break
		elif Mesu == 1:
			BareG(cpt)
			cpt=cpt+1
			if cpt > 7:
				cpt=0
				tabT=[]
			sleep(2)

		if Fichier == True:
			sense.show_letter("F",text_colour=[50,50,50])
		else:
			sense.show_letter("W",text_colour=[50,50,50])
		
		sleep(Tlapse2)

	except (KeyboardInterrupt):
		flagRUN=False
		sense.set_rotation(0)
		Fermer()
		
